//////////////////////////
// Change to correct path
/////////////////////////
path "..\\img";
path "..\\mdl"; 
path "..\\snd";  
path "..\\terrenos";

function mat_bump_metal_init();

bmap metal = <autbump.tga>;  //autbump.tga

// the following code creates a material that adds DOT3 bumpmapping to a model
material mat_metal
{
   skin2 = metal; // set a reptile skin
   scale1 = 1.0; // factor for the skin scale at stage 0

   // define a material effect string
   effect = "

               // declare the used textures and variables
               texture entSkin1; // the entity skin
               texture mtlSkin2; // the bump map
               dword mtlSkill1;  // the light vector

               // default technique
               technique bump_dot3
               {
                  pass P0
                  {
                      // set texture stage states
                      Texture[0] = <mtlSkin2>;
                      Texture[1] = <entSkin1>;
                      TextureFactor = <mtlSkill1>;
  
                      ColorArg1[0] = Texture; // stage 0 = bumpmap
                      ColorOp[0] = DotProduct3;
                      ColorArg2[0] = TFactor;
  
                      ColorArg1[1] = Texture; // stage 1 - skin texture
                      ColorOp[1] = AddSigned;
                      ColorArg2[1] = Current;
  
                      ColorArg1[2] = Diffuse; // stage 2 - lighting
                      ColorOp[2] = Modulate2x;
                      ColorArg2[2] = Current;
                  }
               }

               // fallback technique for devices that do not support bumpmapping
               technique fallback
               {
                  pass P0
                  {
                     // set texture stage states
                     Texture[0] = <entSkin1>;
                     ColorArg1[0] = Texture; // stage 0 = skin texture
                     ColorOp[0] = Modulate2x;
                     ColorArg2[0] = Diffuse; // modulate by lighting
                  }
               }
             "; // end of the effect string
}


function mat_bump_metal_init() 
{
   // initialize the material properties
   vec_set(mat_metal.ambient_blue,  mat_model.ambient_blue);
   vec_set(mat_metal.diffuse_blue,  mat_model.diffuse_blue);
   vec_set(mat_metal.specular_blue, mat_model.specular_blue);
   mat_metal.power = mat_model.power;
   // create the normals map for DOT3 bumpmapping
   bmap_to_normals(mat_metal.skin2,2);
   // set a lighting vector for DOT3 bumpmapping
   mat_metal.skill1 = pixel_for_vec(vector(180,140,140),100,8888);
}

action mat_bump_auto
{
	my.material = mat_metal;
	my.metal = on;
	my.ambient = 50;
	my.albedo = 80;
	my.shadow = on;
}